import {
  Action,
} from './action';

class LPCReducer {

  private reducerMap: Map<string, any[]>;

  private constructor() {
    this.reducerMap = new Map();
  }

  public reducer<State>(state: State, action: Action): State {
    let rm: string[] = action.type.split('.');
    if (null == rm || 2 !== rm.length) {
      console.log(`Method[${action.type}] is not valid.`);
      return null;
    }

    const reducerName: string = rm[0];
    const methodName: string = rm[1];

    if (this.reducerMap.has(reducerName)) {
      let reducers = this.reducerMap.get(reducerName);
      for (let reducer of reducers) {

        state = reducer(state, action);
      }
    }

    return null;
  }


}
